DigestSignatureSpi (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.jcajce.provider.asymmetric.rsa

## Class DigestSignatureSpi

- java.lang.Object
- - java.security.SignatureSpi
  - - org.bouncycastle.jcajce.provider.asymmetric.rsa.DigestSignatureSpi

- Direct Known Subclasses:
    DigestSignatureSpi.MD2, DigestSignatureSpi.MD4, DigestSignatureSpi.MD5, DigestSignatureSpi.noneRSA, DigestSignatureSpi.RIPEMD128, DigestSignatureSpi.RIPEMD160, DigestSignatureSpi.RIPEMD256, DigestSignatureSpi.SHA1, DigestSignatureSpi.SHA224, DigestSignatureSpi.SHA256, DigestSignatureSpi.SHA384, DigestSignatureSpi.SHA512

      public class DigestSignatureSpi
      extends java.security.SignatureSpi

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DigestSignatureSpi.MD2`
    `static class` | `DigestSignatureSpi.MD4`
    `static class` | `DigestSignatureSpi.MD5`
    `static class` | `DigestSignatureSpi.noneRSA`
    `static class` | `DigestSignatureSpi.RIPEMD128`
    `static class` | `DigestSignatureSpi.RIPEMD160`
    `static class` | `DigestSignatureSpi.RIPEMD256`
    `static class` | `DigestSignatureSpi.SHA1`
    `static class` | `DigestSignatureSpi.SHA224`
    `static class` | `DigestSignatureSpi.SHA256`
    `static class` | `DigestSignatureSpi.SHA384`
    `static class` | `DigestSignatureSpi.SHA512`

  - ### Field Summary

    - ### Fields inherited from class java.security.SignatureSpi

      `appRandom`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `DigestSignatureSpi(ASN1ObjectIdentifier objId, Digest digest, AsymmetricBlockCipher cipher)`
    `protected` | `DigestSignatureSpi(Digest digest, AsymmetricBlockCipher cipher)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Object` | `engineGetParameter(java.lang.String param)` Deprecated.
    `protected java.security.AlgorithmParameters` | `engineGetParameters()`
    `protected void` | `engineInitSign(java.security.PrivateKey privateKey)`
    `protected void` | `engineInitVerify(java.security.PublicKey publicKey)`
    `protected void` | `engineSetParameter(java.security.spec.AlgorithmParameterSpec params)`
    `protected void` | `engineSetParameter(java.lang.String param, java.lang.Object value)` Deprecated. replaced with
    `protected byte[]` | `engineSign()`
    `protected void` | `engineUpdate(byte b)`
    `protected void` | `engineUpdate(byte[] b, int off, int len)`
    `protected boolean` | `engineVerify(byte[] sigBytes)`

    - ### Methods inherited from class java.security.SignatureSpi

      `clone, engineInitSign, engineSign, engineUpdate, engineVerify`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DigestSignatureSpi

          protected DigestSignatureSpi(Digest digest,
                            AsymmetricBlockCipher cipher)

    - #### DigestSignatureSpi

          protected DigestSignatureSpi(ASN1ObjectIdentifier objId,
                            Digest digest,
                            AsymmetricBlockCipher cipher)

  - ### Method Detail

    - #### engineInitVerify

          protected void engineInitVerify(java.security.PublicKey publicKey)
                                   throws java.security.InvalidKeyException

      Specified by:
        `engineInitVerify` in class `java.security.SignatureSpi`
      Throws:
        `java.security.InvalidKeyException`

    - #### engineInitSign

          protected void engineInitSign(java.security.PrivateKey privateKey)
                                 throws java.security.InvalidKeyException

      Specified by:
        `engineInitSign` in class `java.security.SignatureSpi`
      Throws:
        `java.security.InvalidKeyException`

    - #### engineUpdate

          protected void engineUpdate(byte b)
                               throws java.security.SignatureException

      Specified by:
        `engineUpdate` in class `java.security.SignatureSpi`
      Throws:
        `java.security.SignatureException`

    - #### engineUpdate

          protected void engineUpdate(byte[] b,
                          int off,
                          int len)
                               throws java.security.SignatureException

      Specified by:
        `engineUpdate` in class `java.security.SignatureSpi`
      Throws:
        `java.security.SignatureException`

    - #### engineSign

          protected byte[] engineSign()
                               throws java.security.SignatureException

      Specified by:
        `engineSign` in class `java.security.SignatureSpi`
      Throws:
        `java.security.SignatureException`

    - #### engineVerify

          protected boolean engineVerify(byte[] sigBytes)
                                  throws java.security.SignatureException

      Specified by:
        `engineVerify` in class `java.security.SignatureSpi`
      Throws:
        `java.security.SignatureException`

    - #### engineSetParameter

          protected void engineSetParameter(java.security.spec.AlgorithmParameterSpec params)

      Overrides:
        `engineSetParameter` in class `java.security.SignatureSpi`

    - #### engineSetParameter

          protected void engineSetParameter(java.lang.String param,
                                java.lang.Object value)

      Deprecated. replaced with
      Specified by:
        `engineSetParameter` in class `java.security.SignatureSpi`

    - #### engineGetParameter

          protected java.lang.Object engineGetParameter(java.lang.String param)

      Deprecated.
      Specified by:
        `engineGetParameter` in class `java.security.SignatureSpi`

    - #### engineGetParameters

          protected java.security.AlgorithmParameters engineGetParameters()

      Overrides:
        `engineGetParameters` in class `java.security.SignatureSpi`